<?php
namespace AustraliaPost\Extensions\Business\API\Wrapper;

class Shipment_Request {

	private $reference;
	private $customer_reference_1;
	private $customer_reference_2;
	private $email_tracking_enabled = true;
	/** @var Address $from */
	private $from;
	/** @var Address $to */
	private $to;

	/**
	 * @return mixed
	 */
	public function getReference() {
		return $this->reference;
	}

	/**
	 * @param mixed $reference
	 *
	 * @return Shipment_Request
	 */
	public function setReference( $reference ) {
		$this->reference = $reference;
		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getCustomerReference1() {
		return $this->customer_reference_1;
	}

	/**
	 * @param mixed $customer_reference_1
	 *
	 * @return Shipment_Request
	 */
	public function setCustomerReference1( $customer_reference_1 ) {
		$this->customer_reference_1 = $customer_reference_1;
		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getCustomerReference2() {
		return $this->customer_reference_2;
	}

	/**
	 * @param mixed $customer_reference_2
	 */
	public function setCustomerReference2( $customer_reference_2 ) {
		$this->customer_reference_2 = $customer_reference_2;
	}

	/**
	 * @return mixed
	 */
	public function getEmailTrackingEnabled() {
		return $this->email_tracking_enabled;
	}

	/**
	 * @param mixed $email_tracking_enabled
	 */
	public function setEmailTrackingEnabled( $email_tracking_enabled ) {
		$this->email_tracking_enabled = $email_tracking_enabled;
	}

	/**
	 * @return Address
	 */
	public function getFrom() {
		return $this->from;
	}

	/**
	 * @param Address $from
	 *
	 * @return Shipment_Request
	 */
	public function setFrom( $from ) {
		$this->from = $from;
		return $this;
	}

	/**
	 * @return Address
	 */
	public function getTo() {
		return $this->to;
	}

	/**
	 * @param Address $to
	 * @return Shipment_Request
	 */
	public function setTo( $to ) {
		$this->to = $to;
		return $this;
	}

	private $items = [];

	/**
	 * @return mixed
	 */
	public function getItems() {
		return $this->items;
	}

	/**
	 * @param $item
	 * @return Shipment_Request
	 */
	public function addItem( $item ) {
		$this->items[] = $item;
		return $this;
	}

	public function getPayLoad(){
		$shipments = [];
		/** @var Price_Item $item */
		foreach ( $this->getItems() as $key => $item ) {
			$item = $item->getPayLoad($this->getTo()->getCountry());
			$shipments[] = [
				'shipment_reference' => sprintf('%s-%s', $this->getReference(), $key),
				'customer_reference_1' => $this->getCustomerReference1(),
				'customer_reference_2' => $this->getCustomerReference2(),
				'email_tracking_enabled' => $this->getEmailTrackingEnabled(),
				'from' => $this->getFrom()->getPayLoad(),
				'to' => $this->getTo()->getPayLoad(),
				'items' => [$item],
			];
		}

		return array('shipments' => $shipments);
	}


}
